p=nextPrime 10^3
kk=ZZ/p
R=kk[x_0..x_2]
g=10
r=2
d=ceiling(g+r-g/(r+1)) 
rho=g-(r+1)*(g-d+r)
rho>=0
delta=binomial(d-1,2)-g 
-- => g,r,d,rho and delta have 
--    the expected values as 
--    in the Exercise
pts=apply(delta,j->random(R^1,R^3))
Ipts=apply(pts,q->ideal(vars R*syz q));
IGamma=intersect Ipts; 
-- The random choice in M2 lead 
-- to delta distinct points, since
degree IGamma==delta 

J=intersect apply(Ipts,I->I^2);
betti res J
-- The expected value for the number forms of 
-- degree d which double at delta points is
binomial(d+2,2)-3*delta 
J'=intersect(J,(ideal gens R)^d);
tal=tally flatten degrees source gens J'
tal#d==binomial(d+2,2)-3*delta
f=gens J*random(source gens J,R^{-d});
IC=ideal f
degree IC==d
singC=saturate ideal jacobian IC;
singC==IGamma 
-- => C has the expected delta ordinary double 
--    as singularities  and is smooth otherwise.

-- Since the eighteen points do not lie on a cubic,
-- no 14 of them lie on a conic, and 
-- no 8 of them lie on a line, 
-- the curve C is absolutely irreducible by Bezout.
betti(fIGamma= res IGamma)
-- => there are no linear relations between the forms of 
--    degree d-4 of IGamma  which proves that the 
--    Petri map is injective at the given point.
S=kk[y_0..y_(g-1)] -- the coordinate ring of PP^(g-1).
betti(LW=gens intersect(IGamma,(ideal gens R)^(d-3)))
RC=R/IC
phi=map(RC,S,LW)
betti(Ican=trim ker phi)
elapsedTime minimalBetti Ican

-- Replacing g by a number g' < 10 
-- in the code above,
-- proves the analogous results 
-- for general curve of genus g'
